//+------------------------------------------------------------------+
//|     David's 4H Trendline auto-trading robot by Steve Hopwood.mq4 |
//|                                  Copyright  2010, Steve Hopwood |
//|                              http://www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define  up "Up"
#define  down "Down"
#define  buy "Buy"
#define  sell "Sell"
#define  none "None"
#define  ranging "Ranging"
#define  confused "Confused, and so cannot trade"
#define  trending "Trending"
#define  opentrade "There is a trade open"
#define  stopped "Trading is stopped"
#define  oldtrendlinename "Traded trend line"
#define  reentrylinename "Re entry line"

//From iExposure
#define SYMBOLS_MAX 1024
#define DEALS          0
#define BUY_LOTS       1
#define BUY_PRICE      2
#define SELL_LOTS      3
#define SELL_PRICE     4
#define NET_LOTS       5
#define PROFIT         6

/*
   

----Trading----
bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take, int magic)
void AddReEntryLine(int type)
bool DoesTradeExist()
double SetTarget(string tradedirection)
void Buy(string comment)
void Sell(string comment)



TREND DETECTION MODULE
----Trend direction----
void GetTheTrend()
void CalculateTrendLine()
void DrawTrendLine(color lc, string name)
void GetRsiTrend()
void GetAtrTrend()
void GetAdxTrend()
string GetLsmaTrend(int tf, int shift)

----Trade management module----
void TradeManagementModule()
void BreakEvenStopLoss()
bool CheckForHiddenStopLossHit(int type, int iPipsAboveVisual, double stop )
void JumpingStopLoss() 
void HiddenTakeProfit()
void HiddenStopLoss()
void TrailingStopLoss()

----1.1.3.3 recovery module----
void RecoveryModule()
void CountOpenTrades()
void CheckRecoveryTakeProfit()
int Analyze()
int SymbolsIndex(string SymbolName)
void ModifyTakeProfit(double NewTake);

*/

extern string  gen="----General inputs----";
extern double  Lot=0.01;
extern bool    CriminalIsECN=false;
extern int     ReEntryLinePips=200;
extern color   ReEntryLineColour=Turquoise;
extern bool    StopTrading=false;
extern int     MagicNumber=0;
extern string  TradeComment="";
extern bool    Use1.1.3.3Recovery=true;
extern string  bl13="-------------------------------------------------------------";
extern string  tlis="----Trend line----";
extern string  TrendLineName="Trading robot trend line";
extern color   TrendLineColour=Yellow;
extern color   TrendLineRecordColour=Turquoise;
extern string  bl14="-------------------------------------------------------------";
extern string  tpi="----Take profit and stop loss inputs----";
extern int     TakeProfit=0;
extern bool    UseSixthsTp = false;
extern bool    UseBollingerTp = false;
extern bool    UseAtrTp=true;
extern int     AtrTpPeriod=14;
extern int     AtrTpTimeFrame=0;
extern double  AtrTpMultiplier=3;
extern int     MinimumTargetinPips = 50;
extern string  htp="Hidden take profit settings";
extern bool    HideTakeProfitEnabled=false;
extern int     HiddenTakeProfitPips=20;
extern string  sli="Stop loss for catastrophic events";
extern int     EmergencyStopLoss=999;
extern string  bl4="-------------------------------------------------------------";
extern string  tmm="----Trade management module----";
extern bool    DoNotOverload5DigitCriminals=true;
extern string  BE="Break even settings";
extern bool    BreakEven=true;
extern int     BreakEvenPips=25;
extern int     BreakEvenProfit=10;
extern bool    HideBreakEvenStop=false;
extern int     PipsAwayFromVisualBE=5;
extern string  JSL="Jumping stop loss settings";
extern bool    JumpingStop=true;
extern int     JumpingStopPips=50;
extern bool    AddBEP=true;
extern bool    JumpAfterBreakevenOnly=false;
extern bool    HideJumpingStop=false;
extern int     PipsAwayFromVisualJS=10;
extern string  TSL="Trailing stop loss settings";
extern bool    TrailingStop=false;
extern int     TrailingStopPips=50;
extern bool    HideTrailingStop=false;
extern int     PipsAwayFromVisualTS=10;
extern bool    TrailAfterBreakevenOnly=false;
extern bool    StopTrailAtPipsProfit=false;
extern int     StopTrailPips=0;
extern string  hsl1="Hidden stop loss settings";
extern bool    HideStopLossEnabled=false;
extern int     HiddenStopLossPips=20;
extern string  bl1="-------------------------------------------------------------";
extern string  tm="----Trend detection module----";
extern string  mts="Manual trend-setting";
extern bool    TrendIsUp=false;
extern bool    TrendIsDown=false;
extern string  ats="Automatic trend detection";
extern bool    AutoDetectTrend=true;
extern string  rsin="----Rsi----";
extern bool    UseRsi=true;
extern int     RsiTf=0;
extern int     RsiPeriod=21;
extern string  atri="----Atr----";
extern bool    UseAtr=false;
extern int     AtrTf=0;
extern int     AtrPeriod=21;
extern int     DaysToLookBack=10;
extern string  adxin="----Adx----";
extern bool    UseAdx=false;
extern int     AdxTf=0;
extern int     AdxPeriod=21;
extern string  ls="----LSMA----";
extern bool    UseLSMA=false;
extern int     LSMAPeriod=21;
extern int     LSMATf=0;
extern string  tt="----Trading hours----";
extern string  Trade_Hours= "Set Morning & Evening Hours";
extern string  Trade_Hoursi= "Use 24 hour, local time clock";
extern string  Trade_Hours_M= "Morning Hours 0-12";
extern  int    start_hourm = 7;
extern  int    end_hourm = 12;
extern string  Trade_Hours_E= "Evening Hours 12-24";
extern  int    start_houre = 12;
extern  int    end_houre = 18;
extern string  bl2="-------------------------------------------------------------";
extern string  mis="----Odds and ends----";
extern int     DisplayGapSize=30;
extern bool    ShowAlerts=true;


//Trading variables
int            TicketNo, OpenTrades, SendMagicNumber;
double         LotSize, TargetPrice;

//Trade direction
int            OldBars;
string         TradingStatus;
//Trend
double         TrendRsiVal, TrendAtrVal;
double         AdxVal, AdxPlusDI, AdxMinusDI;
string         RsiTrend, AtrTrend, AdxTrend, LsmaTrend, trend;
//Trend line
double         Leg2, Leg1;
int            Leg2Time, Leg1Time;

//2.4.2 recover
bool           RecoveryInProgress, TpMoved;
string ExtSymbols[SYMBOLS_MAX];
int    ExtSymbolsTotal=0;
double ExtSymbolsSummaries[SYMBOLS_MAX][7];
int    ExtLines=-1;
string ExtCols[8]={"Symbol",
                   "Deals",
                   "Buy lots",
                   "Buy price",
                   "Sell lots",
                   "Sell price",
                   "Net lots",
                   "Profit"};
int    ExtShifts[8]={ 10, 80, 130, 180, 260, 310, 390, 460 };
int    ExtVertShift=14;
double buy_price=0.0;
double sell_price=0.0;
         

//Misc
string         Gap, ScreenMessage;

void DisplayUserFeedback()
{
   if (IsTesting() && !IsVisualMode()) return;

   ScreenMessage = "";
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   //Code for time to bar-end display from Candle Time by Nick Bilak
   double i;
   int m,s,k;
   m=Time[0]+Period()*60-CurTime();
   i=m/60.0;
   s=m%60;
   m=(m-m%60)/60;
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, m + " minutes " + s + " seconds left to bar end", NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);      
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Lot size: ", Lot, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Magic number: ", SendMagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trend: ", trend, NL);
   if (trend == up && TargetPrice != 0) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "I will BUY at: ", DoubleToStr(TargetPrice, Digits), NL);
   if (trend == down && TargetPrice != 0) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "I will SELL at: ", DoubleToStr(TargetPrice, Digits), NL);
   if (trend == ranging) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Not trading a ranging market", NL);
   if (AutoDetectTrend) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Automatic trend detection is turned on", NL);
   if (!AutoDetectTrend) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Automatic trend detection is turned off", NL);
   
/*
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);      
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Lot size: ", Lot, NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Take profit: ", TakeProfit, " pips",  NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Emergency stop loss: ", FontSize, " pips",  NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Magic number: ", MagicNumber, NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trade comment: ", TradeComment, NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Tolerance: ", Tolerance, NL);
      if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "CriminalIsECN = true", NL);
      else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "CriminalIsECN = false", NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Criminal's minimum lot size: ", MarketInfo(Symbol(), MODE_MINLOT), NL, NL );
      if (CriminalAllowsHedging)
      {
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Hedging inputs:", NL);
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "      HedgeAtLossPips: ", HedgeAtLossPips, " pips", NL);
         //ScreenMessage = StringConcatenate(ScreenMessage,Gap, "      HedgeProfitTarget: ", HedgeProfitTarget, " pips", NL);
      }//if (CriminalAllowsHedging)
*/      
      Comment(ScreenMessage);


}//void DisplayUserFeedback()


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----
   Gap="";
   if (DisplayGapSize >0)
   {
      for (int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }//if (DisplayGapSize >0)
   
   int multiplier;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   if(Digits == 7) multiplier = 1000;   
   
   TakeProfit*= multiplier;
   EmergencyStopLoss*= multiplier;
   ReEntryLinePips*= multiplier;
   BreakEvenPips*= multiplier;
   BreakEvenProfit*= multiplier;
   PipsAwayFromVisualBE*= multiplier;
   JumpingStopPips*= multiplier;
   PipsAwayFromVisualJS*= multiplier;
   MinimumTargetinPips*= multiplier;
   TrailingStopPips*= multiplier;
   PipsAwayFromVisualTS*= multiplier;
   StopTrailPips*= multiplier;
   HiddenStopLossPips*= multiplier;
   HiddenTakeProfitPips*= multiplier;
   
   if (TradeComment=="") TradeComment = " ";
     
   LotSize = Lot;
   SendMagicNumber = MagicNumber;
   
   Comment("..........................Waiting for the first tick");
   //start();
   
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
//----
   return(0);
}
///////////////////////////////////////////////////////////////////////////////////////////
//TREND DETECTION MODULE

void GetRsiTrend()
{
   //TrendRsiVal = GetRsi(0);
   trend = ranging;
   double tf = RsiTf;
   if (tf == 0) tf = Period();
   
   TrendRsiVal = iRSI(NULL, tf, RsiPeriod, PRICE_CLOSE, 0);

   if (TrendRsiVal > 55) RsiTrend = up;
   if (TrendRsiVal < 45) RsiTrend = down;
   

}//End void GetRsiTrend()


void GetAtrTrend()
{
   double PriceNow = Bid;
   double tf = AtrTf;
   if (AtrTf == 0) tf = Period();
   double ComparePrice = iOpen(NULL, tf, DaysToLookBack);
   
   TrendAtrVal = iATR(NULL, tf, AtrPeriod, 0);

   double x2TrendAtrVal = TrendAtrVal * 2;
   
   AtrTrend = ranging;
   if (PriceNow > ComparePrice) 
   {
      double TrendLevel = NormalizeDouble(ComparePrice + x2TrendAtrVal, Digits);
      if (Ask > TrendLevel) AtrTrend = up;
   }//if (PriceNow > ComparePrice) 
   
   if (PriceNow < ComparePrice) 
   {
      TrendLevel = NormalizeDouble(ComparePrice - x2TrendAtrVal, Digits);
      if (Bid < TrendLevel) AtrTrend = down;
   }//if (PriceNow > ComparePrice) 
   

}//End void GetAtrTrend()

void GetAdxTrend()
{
   AdxTrend = ranging;
   double tf = AdxTf;
   if (AdxTf == 0) tf = Period();
   double PreviousAdxVal = iADX(NULL, tf, AdxPeriod, PRICE_CLOSE, MODE_MAIN, 1);
   

   AdxVal = iADX(NULL, tf, AdxPeriod, PRICE_CLOSE, MODE_MAIN, 0);
   AdxPlusDI = iADX(NULL, tf, AdxPeriod, PRICE_CLOSE, MODE_PLUSDI, 0);
   AdxMinusDI = iADX(NULL, tf, AdxPeriod, PRICE_CLOSE, MODE_MINUSDI, 0);
   
   if (AdxVal < PreviousAdxVal) return;//No trend so nothing to do
   
   if (AdxPlusDI > AdxMinusDI)//trend is up
   {
      AdxTrend = up;
      return;
   }//if (AdxPlusDI > AdxMinusDI) 
   
   //Trend is neither up nor ranging
   AdxTrend = down;
   
}//End void GetAdxTrend()

double iLsma(int tf,int shift)
{
   //Code to calculate LSMA value. Copied from MrPip's work. Many thanks, MrPip
   
   double wt;
   
   double ma1=iMA(NULL,LSMATf,LSMAPeriod,0,MODE_SMA ,PRICE_CLOSE,shift);
   double ma2=iMA(NULL,LSMATf,LSMAPeriod,0,MODE_LWMA,PRICE_CLOSE,shift);
   wt = MathFloor((3.0*ma2-2.0*ma1)/Point) * Point;
   return(wt);
}//double iLsma(int LSMAPeriod,int shift)  

string GetLsmaTrend(int tf, int shift)
{
   LsmaTrend = ranging;
   double lsma_cur, lsma_prev;
   
   lsma_cur = iLsma(tf, shift);
   lsma_prev = iLsma(tf, shift + 1);
   if (lsma_cur > lsma_prev) LsmaTrend = up;
   if (lsma_cur < lsma_prev) LsmaTrend = down;
   
   return(LsmaTrend);

}//End string GetLsmaTrend()

void CalculateTrendLine()
{

   Leg2 = 0; Leg1 = 0;
   int PointsFound, cc;
   Leg2Time = 0; Leg1Time = 0;
   ObjectDelete(oldtrendlinename);

   //Find rising zigzag for downtrend
   if (trend == down)
   {
      PointsFound = 0;
      cc = 0;
      Leg2 = 0;
      Leg1 = 0;
      while (PointsFound < 2)
      {
         cc++;         
         double zzUpper = iCustom(NULL,0,"ZigZag",5,5,3,1,cc); 
         if (zzUpper > 0)
         {
            if (PointsFound == 0)
            {
               Leg2 = zzUpper;
               zzUpper = -1;
               Leg2Time = iTime(NULL,0,iHighest(NULL,0,MODE_HIGH, 1440/Period(), 
               iBarShift(NULL,0,iTime(NULL,0,cc - 1),false)));
               PointsFound++;
            }//if (PointsFound == 0)
            
            if (PointsFound == 1 && zzUpper > Leg2)
            {
               Leg1 = zzUpper;
               Leg1Time = iTime(NULL,0,iHighest(NULL,0,MODE_HIGH, 1440/Period(), 
               iBarShift(NULL,0,iTime(NULL,0,cc - 1),false)));
               PointsFound++;
            }//if (PointsFound == 1)
            
            if (PointsFound == 2)
            {
               ObjectCreate(TrendLineName, OBJ_TREND, 0, Leg1Time, Leg1, Leg2Time, Leg2);
               ObjectSet(TrendLineName, OBJPROP_COLOR, TrendLineColour);

               //Check that the trendline is valid - must not be pierced at any point
               for (int d = cc; d >= 0; d--)
               {
                  double target = NormalizeDouble(ObjectGetValueByShift(TrendLineName, d), Digits);
                     
                  if (High[d] > target)
                  {
                     Leg2 = High[d];
                     
                     Leg2Time = Time[d];
                     ObjectDelete(TrendLineName);
                     DrawTrendLine(TrendLineColour, TrendLineName);
                     Comment("Sleeping for 2 minutes");
                     Sleep(60000 * 2);
                     return;
                  }//if (High[d] > target)
                  
                  
               }//for (int d = cc-1; d >= 0; d--)
               

            }//if (PointsFound == 2)

            
         }//if (zzUpper > 0)
         
         //double zzLower = iCustome(NULL,0,"ZigZag",12,5,3,1,cc); // from 2nd buffer
         if (cc == Bars) return;
         
      }//while (PointsFound < 2)
      
   }//if (trend == down)
   
   
   //Find falling zigzag for uptrend
   if (trend == up)
   {
      PointsFound = 0;
      cc = 0;
      Leg2 = 0;
      Leg1 = 0;
      while (PointsFound < 2)
      {
         cc++;         
         double zzLower = iCustom(NULL,0,"ZigZag",5,5,3,2,cc); 
         if (zzLower > 0)
         {
            if (PointsFound == 0)
            {
               Leg2 = zzLower;
               zzLower = -1;
               Leg2Time = iTime(NULL,0,iLowest(NULL,0,MODE_LOW, 1440/Period(), 
               iBarShift(NULL,0,iTime(NULL,0,cc - 1),false)));
               PointsFound++;
            }//if (PointsFound == 0)
            
            if (PointsFound == 1 && zzLower < Leg2 && zzLower > 0)
            {
               Leg1 = zzLower;
               //Leg1 = Low[cc];
               Leg1Time = iTime(NULL,0,iLowest(NULL,0,MODE_LOW, 1440/Period(), 
               iBarShift(NULL,0,iTime(NULL,0,cc - 1),false)));
               PointsFound++;
            }//if (PointsFound == 1)
            
            if (PointsFound == 2)
            {
               ObjectCreate(TrendLineName, OBJ_TREND, 0, Leg1Time, Leg1, Leg2Time, Leg2);
               ObjectSet(TrendLineName, OBJPROP_COLOR, TrendLineColour);

               //Check that the trendline is valid - must not be pierced at any point
               for (d = cc; d >= 0; d--)
               {
                  target = NormalizeDouble(ObjectGetValueByShift(TrendLineName, d), Digits);
                     
                  if (Low[d] < target)
                  {
                     Leg2 = Low[d];
                     
                     Leg2Time = Time[d];
                     ObjectDelete(TrendLineName);
                     DrawTrendLine(TrendLineColour, TrendLineName);
                     Comment("Sleeping for 2 minutes");
                     Sleep(120000);
                     return;
                  }//if (High[d] > target)
                  
                  
               }//for (int d = cc-1; d >= 0; d--)
               

            }//if (PointsFound == 2)

            
         }//if (zzLower > 0)
         
         //double zzLower = iCustome(NULL,0,"ZigZag",12,5,3,1,cc); // from 2nd buffer
         if (cc == Bars) return;
         
      }//while (PointsFound < 2)
      
   }//if (trend == up)
   
   
   
   
}//End void CalculateTrendLine()

void DrawTrendLine(color lc, string name)
{
   //lc = line colour
   ObjectCreate(name, OBJ_TREND, 0, Leg1Time, Leg1, Leg2Time, Leg2);
   ObjectSet(name, OBJPROP_COLOR, lc);
               

}//void DrawTrendLine(color lc, string name)


void GetTheTrend()
{
   trend = "";
   string oldtrend = "";
   
   //Rsi
   if (UseRsi)
   {
      GetRsiTrend();
      trend = RsiTrend;
      oldtrend = trend;
   }//if (UseRsi)
   
   //Rsi
   if (UseAtr)
   {
      GetAtrTrend();
      trend = AtrTrend;
      if (trend != oldtrend && oldtrend != "")
      {
         trend = confused;
         return;
      }//if (trend != oldtrend)
      oldtrend = trend;
   }//if (UseRsi)
   
   //Axx
   if (UseAdx)
   {
      GetAdxTrend();
      trend = AdxTrend;
      if (trend != oldtrend && oldtrend != "")
      {
         trend = confused;
         return;
      }//if (trend != oldtrend)
      oldtrend = trend;
   }//if (UseRsi)
   
   //LSMA - MrPips
   if (UseLSMA)
   {
      string PrevTrend = GetLsmaTrend(LSMATf, 1);
      LsmaTrend = GetLsmaTrend(LSMATf, 0);  
      if (LsmaTrend == up && (PrevTrend == ranging || PrevTrend == down) ) trend = up;
      if (LsmaTrend == down && (PrevTrend == ranging || PrevTrend == up) ) trend = down;   
      trend = LsmaTrend;
      if (trend != oldtrend && oldtrend != "")
      {
         trend = confused;
         return;
      }//if (trend != oldtrend)
      oldtrend = trend;
   }//if (UseLSMA)
   //Alert(LsmaTrend);
   
   
   
}//End void GetTheTrend()


//END TREND DETECTION MODULE
///////////////////////////////////////////////////////////////////////////////////////////


bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take, int magic)
{
   
   //if (StopTrading) return(true);
   /*
   if (!IsTesting())
   {   
      if (!IsTradeAllowed() ) return(false);
      if (!IsConnected() ) return(false);
      if (!IsExpertEnabled() ) return(false);
      if (!IsTradeContextBusy() ) return(false);
   }//if (!IsTesting)
   */
   
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   color col = Red;
   if (type == OP_BUY || type == OP_BUYSTOP) col = Green;
   
   int expiry = 0;
   //if (SendPendingTrades) expiry = TimeCurrent() + (PendingExpiryMinutes * 60);
   
   
   if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, magic, expiry, col);
   
   
   //Is a 2 stage criminal
   if (CriminalIsECN)
   {
      ticket = OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, magic, expiry, col);
	   if (stop != 0)
	   {
		   if (ticket > 0)
		   bool result = OrderModify(ticket, OrderOpenPrice(), stop, take, 0, CLR_NONE);
		   if (!result)
		   {
		       int err=GetLastError();
             Print(Symbol(), " ", type," SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
		   }//if (!result)			  
	   }//if (Sl != 0)
      
      
   }//if (CriminalIsECN)
   
   //Error trapping for both
   if (ticket < 0)
   {
      string stype;
      if (type == OP_BUY) stype = "OP_BUY";
      if (type == OP_BUYSTOP) stype = "OP_BUYSTOP";
      if (type == OP_SELL) stype = "OP_SELL";
      if (type == OP_SELLSTOP) stype = "OP_SELLSTOP";
      err=GetLastError();
      Alert(Symbol(), " ", stype," David H4 order send failed with error(",err,"): ",ErrorDescription(err));
      Print(Symbol(), " ", stype," David H4 order send failed with error(",err,"): ",ErrorDescription(err));
      return(false);
   }//if (ticket < 0)  
   
   //Got this far, so trade send succeeded
   Sleep(5000);
   //Recovery
   OpenTrades++;
   if (OpenTrades > 1)
   {
      TpMoved = false;
      RecoveryInProgress = true;
   }//if (OpenTrades > 1)
   
   return(true);
   
}//End bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)

bool DoesTradeExist()
{
   
   TicketNo = 0;
   
   if (OrdersTotal() == 0) return(false);
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      
      if ( OrderMagicNumber() == SendMagicNumber && OrderSymbol() == Symbol() )      
      {
         TicketNo = OrderTicket();
         return(true);         
      }//if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)

   return(false);

}//End bool DoesTradeExist()




double SetTarget(string tradedirection)
{
   double target = 0;
   if (tradedirection == sell) // SELL
   {
      if (UseAtrTp) // use Atr
      {
         double AtrVal = iATR(Symbol(), AtrTpTimeFrame, AtrTpPeriod, 0) * AtrTpMultiplier;
         target = NormalizeDouble(Bid - AtrVal,Digits);
      }//if (UseAtrTp) 
      
   }//if (tradedirection == sell)
   
   if (tradedirection == buy) // BUY
   {
      if (UseAtrTp) // use Atr
      {
         AtrVal = iATR(Symbol(), AtrTpTimeFrame, AtrTpPeriod, 0) * AtrTpMultiplier;
         target = NormalizeDouble(Ask + AtrVal,Digits);
      }//if (UseAtrTp) 
      
      
   }//if (tradedirection == buy)
   return (NormalizeDouble(target,Digits));
}//End double SetTarget(string tradedirection)

void Buy(string comment)
{
     /* if ( DoesTrendTradeExist() )
   { CloseTrendTrade(99); } */
   
   if (DoesTradeExist()) return;
   if (ObjectFind(reentrylinename) > -1) ObjectDelete(reentrylinename);

  
   double stop = NormalizeDouble(Ask - (EmergencyStopLoss * Point),Digits);
   if (EmergencyStopLoss == 0) stop = 0;
   double take = NormalizeDouble(Ask + (TakeProfit * Point),Digits);
   if (TakeProfit == 0) take = 0;
   
   if (take == 0) // if no fixed take profit, check use options for calculating take profit
   {
      take = SetTarget(buy);
   }
   
   bool result = SendSingleTrade(OP_BUY, comment, LotSize, Ask, stop, take, SendMagicNumber);
   if (result) 
   {
      AddReEntryLine(OP_BUY);
   }//if (result)

}//End void Buy(string comment)


void Sell(string comment)
{
  /* if ( DoesTrendTradeExist() )
   { CloseTrendTrade(9); } */
   
   if (DoesTradeExist()) return;
   if (ObjectFind(reentrylinename) > -1) ObjectDelete(reentrylinename);
   
   double stop = NormalizeDouble(Bid + (EmergencyStopLoss * Point),Digits);
   if (EmergencyStopLoss == 0) stop = 0;
   double take = NormalizeDouble(Bid - (TakeProfit * Point),Digits);
   if (TakeProfit == 0) take = 0;
   
   if (take == 0) // if no fixed take profit, check use options for calculating take profit
   {
      take = SetTarget(sell);
   }

   bool result = SendSingleTrade(OP_SELL, comment, LotSize, Bid, stop, take, SendMagicNumber);
   if (result) 
   {
      TradingStatus = opentrade;
      AddReEntryLine(OP_SELL);
   }//if (result)
}//End void Sell(string comment)


void AddReEntryLine(int type)
{

      RefreshRates();
      
      if (type == OP_BUY)
      {
         double LinePrice = NormalizeDouble(Ask - (ReEntryLinePips * Point), Digits);
         ObjectCreate(reentrylinename,OBJ_HLINE,0,TimeCurrent(),LinePrice);
         ObjectSet(reentrylinename,OBJPROP_COLOR,ReEntryLineColour);
         ObjectSet(reentrylinename,OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet(reentrylinename,OBJPROP_WIDTH,2);     

      }//if (type == OP_BUY)
      
      if (type == OP_SELL)
      {
         LinePrice = NormalizeDouble(Bid + (ReEntryLinePips * Point), Digits);
         ObjectCreate(reentrylinename,OBJ_HLINE,0,TimeCurrent(),LinePrice);
         ObjectSet(reentrylinename,OBJPROP_COLOR,ReEntryLineColour);
         ObjectSet(reentrylinename,OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet(reentrylinename,OBJPROP_WIDTH,2);     

      }//if (type == OP_SELL)



}//void AddReEntryLine(int type)

////////////////////////////////////////////////////////////////////////////////////////////////
//TRADE MANAGEMENT MODULE

bool CheckForHiddenStopLossHit(int type, int iPipsAboveVisual, double stop )
{
   //Reusable code that can be called by any of the stop loss manipulation routines except HiddenStopLoss().
   //Checks to see if the market has hit the hidden sl and attempts to close the trade if so. 
   //Returns true if trade closure is successful, else returns false
   
   //Check buy trade
   if (type == OP_BUY)
   {
      double sl = NormalizeDouble(stop + (iPipsAboveVisual * Point), Digits);
      if (Bid <= sl)
      {
         bool result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5, CLR_NONE);
         if (result)
         {
            if (ShowAlerts==true) Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket());      
         }//if (result)
         else
         {
            int err=GetLastError();
            if (ShowAlerts==true) Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
            Print("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
         }//else
      }//if (Bid <= sl)  
   }//if (type = OP_BUY)
   
   //Check buy trade
   if (type == OP_SELL)
   {
      sl = NormalizeDouble(stop - (iPipsAboveVisual * Point), Digits);
      if (Ask >= sl)
      {
         result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5, CLR_NONE);
         if (result)
         {
            if (ShowAlerts==true) Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket());      
         }//if (result)
         else
         {
            err=GetLastError();
            if (ShowAlerts==true) Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
            Print("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
         }//else
      }//if (Ask >= sl)  
   }//if (type = OP_SELL)
   

}//End bool CheckForHiddenStopLossHit(int type, int iPipsAboveVisual, double stop )


void BreakEvenStopLoss() // Move stop loss to breakeven
{

   //Check hidden BE for trade closure
   if (HideBreakEvenStop)
   {
      bool TradeClosed = CheckForHiddenStopLossHit(OrderType(), PipsAwayFromVisualBE, OrderStopLoss() );
      if (TradeClosed) return;//Trade has closed, so nothing else to do
   }//if (HideBreakEvenStop)


   bool result;

           
   if (OrderType()==OP_BUY)
         {
            if (Bid >= OrderOpenPrice () + (Point*BreakEvenPips) && 
                OrderStopLoss()<OrderOpenPrice())
            {
               result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(BreakEvenProfit*Point),OrderTakeProfit(),0,CLR_NONE);
               if (result && ShowAlerts==true) Alert("Breakeven set on ", OrderSymbol(), " ticket no ", OrderTicket());
               Print("Breakeven set on ", OrderSymbol(), " ticket no ", OrderTicket());
               if (!result)
               {
                  int err=GetLastError();
                  if (ShowAlerts==true) Alert("Setting of breakeven SL ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
                  Print("Setting of breakeven SL ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
               }//if !result && ShowAlerts)      
               //if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
               //{
               //   bool PartCloseSuccess = PartCloseTradeFunction();
               //   if (!PartCloseSuccess) SetAGlobalTicketVariable();
               //}//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
            }
   	   }               			         
          
   if (OrderType()==OP_SELL)
         {
           if (Ask <= OrderOpenPrice() - (Point*BreakEvenPips) &&
              (OrderStopLoss()>OrderOpenPrice()|| OrderStopLoss()==0)) 
            {
               result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(BreakEvenProfit*Point),OrderTakeProfit(),0,CLR_NONE);
               if (result && ShowAlerts==true) Alert("Breakeven set on ", OrderSymbol(), " ticket no ", OrderTicket());
               Print("Breakeven set on ", OrderSymbol(), " ticket no ", OrderTicket());
               if (!result && ShowAlerts)
               {
                  err=GetLastError();
                  if (ShowAlerts==true) Alert("Setting of breakeven SL ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
                  Print("Setting of breakeven SL ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
               }//if !result && ShowAlerts)      
              //if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
              // {
              //    PartCloseSuccess = PartCloseTradeFunction();
              //    if (!PartCloseSuccess) SetAGlobalTicketVariable();
              // }//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
            }    
         }
      

} // End BreakevenStopLoss sub

void JumpingStopLoss() 
{
   // Jump sl by pips and at intervals chosen by user .
   // Also carry out partial closure if the user requires this

   // Abort the routine if JumpAfterBreakevenOnly is set to true and be sl is not yet set
   if (JumpAfterBreakevenOnly && OrderType()==OP_BUY)
   {
      if(OrderStopLoss()<OrderOpenPrice()) return(0);
   }
  
   if (JumpAfterBreakevenOnly && OrderType()==OP_SELL)
   {
      if(OrderStopLoss()>OrderOpenPrice()) return(0);
   }
  
   double sl=OrderStopLoss(); //Stop loss

   if (OrderType()==OP_BUY)
   {
      //Check hidden js for trade closure
      if (HideJumpingStop)
      {
         bool TradeClosed = CheckForHiddenStopLossHit(OP_BUY, PipsAwayFromVisualJS, OrderStopLoss() );
         if (TradeClosed) return;//Trade has closed, so nothing else to do
      }//if (HideJumpingStop)
      
      // First check if sl needs setting to breakeven
      if (sl==0 || sl<OrderOpenPrice())
      {
         if (Ask >= OrderOpenPrice() + (JumpingStopPips*Point))
         {
            sl=OrderOpenPrice();
            if (AddBEP==true) sl=sl+(BreakEvenProfit*Point); // If user wants to add a profit to the break even
            bool result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
            if (result)
            {
               if (ShowAlerts==true) Alert("Jumping stop set at breakeven ",sl, " ", OrderSymbol(), " ticket no ", OrderTicket());
               Print("Jumping stop set at breakeven: ", OrderSymbol(), ": SL ", sl, ": Ask ", Bid);
               //if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
               //{
                  //bool PartCloseSuccess = PartCloseTradeFunction();
                  //if (!PartCloseSuccess) SetAGlobalTicketVariable();
               //}//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
            }//if (result)
            if (!result)
            {
               int err=GetLastError();
               if (ShowAlerts) Alert(OrderSymbol(), " buy trade. Jumping stop function failed to set SL at breakeven, with error(",err,"): ",ErrorDescription(err));
               Print(OrderSymbol(), " buy trade. Jumping stop function failed to set SL at breakeven, with error(",err,"): ",ErrorDescription(err));
            }//if (!result)
             
            return(0);
         }//if (Ask >= OrderOpenPrice() + (JumpingStopPips*Point))
      } //close if (sl==0 || sl<OrderOpenPrice()

  
      // Increment sl by sl + JumpingStopPips.
      // This will happen when market price >= (sl + JumpingStopPips)
      if (Bid>= sl + ((JumpingStopPips*2)*Point) && sl>= OrderOpenPrice())      
      {
         sl=sl+(JumpingStopPips*Point);
         result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
         if (result)
         {
            if (ShowAlerts==true) Alert("Jumping stop set at ",sl, " ", OrderSymbol(), " ticket no ", OrderTicket());
            Print("Jumping stop set: ", OrderSymbol(), ": SL ", sl, ": Ask ", Ask);
            //if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
            //{
               //PartCloseSuccess = PartCloseTradeFunction();
               //if (!PartCloseSuccess) SetAGlobalTicketVariable();
            //}//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
         }//if (result)
         if (!result)
         {
            err=GetLastError();
            if (ShowAlerts) Alert(OrderSymbol(), " buy trade. Jumping stop function failed with error(",err,"): ",ErrorDescription(err));
            Print(OrderSymbol(), " buy trade. Jumping stop function failed with error(",err,"): ",ErrorDescription(err));
         }//if (!result)
             
      }// if (Bid>= sl + (JumpingStopPips*Point) && sl>= OrderOpenPrice())      
   }//if (OrderType()==OP_BUY)
   
   if (OrderType()==OP_SELL)
   {
      //Check hidden js for trade closure
      if (HideJumpingStop)
      {
         TradeClosed = CheckForHiddenStopLossHit(OP_SELL, PipsAwayFromVisualJS, OrderStopLoss() );
         if (TradeClosed) return;//Trade has closed, so nothing else to do
      }//if (HideJumpingStop)
            
      // First check if sl needs setting to breakeven
      if (sl==0 || sl>OrderOpenPrice())
      {
         if (Ask <= OrderOpenPrice() - (JumpingStopPips*Point))
         {
            sl = OrderOpenPrice();
            if (AddBEP==true) sl=sl-(BreakEvenProfit*Point); // If user wants to add a profit to the break even
            result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
            if (result)
            {
               //if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
               //{
                 // PartCloseSuccess = PartCloseTradeFunction();
                  //if (!PartCloseSuccess) SetAGlobalTicketVariable();
               //}//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
            }//if (result)
            if (!result)
            {
               err=GetLastError();
               if (ShowAlerts) Alert(OrderSymbol(), " sell trade. Jumping stop function failed to set SL at breakeven, with error(",err,"): ",ErrorDescription(err));
               Print(OrderSymbol(), " sell trade. Jumping stop function failed to set SL at breakeven, with error(",err,"): ",ErrorDescription(err));
            }//if (!result)
             
            return(0);
         }//if (Ask <= OrderOpenPrice() - (JumpingStopPips*Point))
      } // if (sl==0 || sl>OrderOpenPrice()
   
      // Decrement sl by sl - JumpingStopPips.
      // This will happen when market price <= (sl - JumpingStopPips)
      if (Bid<= sl - ((JumpingStopPips*2)*Point) && sl<= OrderOpenPrice())      
      {
         sl=sl-(JumpingStopPips*Point);
         result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
         if (result)
         {
            if (ShowAlerts==true) Alert("Jumping stop set at ",sl, " ", OrderSymbol(), " ticket no ", OrderTicket());
            Print("Jumping stop set: ", OrderSymbol(), ": SL ", sl, ": Ask ", Ask);
            //if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
            //{
              // PartCloseSuccess = PartCloseTradeFunction();
               //if (!PartCloseSuccess) SetAGlobalTicketVariable();
            //}//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
         }//if (result)          
         if (!result)
         {
            err=GetLastError();
            if (ShowAlerts) Alert(OrderSymbol(), " sell trade. Jumping stop function failed with error(",err,"): ",ErrorDescription(err));
            Print(OrderSymbol(), " sell trade. Jumping stop function failed with error(",err,"): ",ErrorDescription(err));
         }//if (!result)

      }// close if (Bid>= sl + (JumpingStopPips*Point) && sl>= OrderOpenPrice())         
   }//if (OrderType()==OP_SELL)

} //End of JumpingStopLoss sub

void HiddenStopLoss()
{
   //Called from ManageTrade if HideStopLossEnabled = true


   //Should the order close because the stop has been passed?
   //Buy trade
   if (OrderType() == OP_BUY)
   {
      double sl = NormalizeDouble(OrderOpenPrice() - (HiddenStopLossPips * Point), Digits);
      if (Bid <= sl)
      {
         bool result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5, CLR_NONE);
         if (result)
         {
            if (ShowAlerts==true) Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket());      
         }//if (result)
         else
         {
            int err=GetLastError();
            if (ShowAlerts==true) Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
            Print("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
         }//else
      }//if (Bid <= sl)      
   }//if (OrderType() == OP_BUY)
   
   //Sell trade
   if (OrderType() == OP_SELL)
   {
      sl = NormalizeDouble(OrderOpenPrice() + (HiddenStopLossPips * Point), Digits);
      if (Ask >= sl)
      {
         result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5, CLR_NONE);
         if (result)
         {
            if (ShowAlerts==true) Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket());      
         }//if (result)
         else
         {
            err=GetLastError();
            if (ShowAlerts==true) Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
            Print("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
         }//else
      }//if (Ask >= sl)   
   }//if (OrderType() == OP_SELL)
   

}//End void HiddenStopLoss()

void HiddenTakeProfit()
{
   //Called from ManageTrade if HideStopLossEnabled = true


   //Should the order close because the stop has been passed?
   //Buy trade
   if (OrderType() == OP_BUY)
   {
      double tp = NormalizeDouble(OrderOpenPrice() + (HiddenTakeProfitPips * Point), Digits);
      if (Bid >= tp)
      {
         bool result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5, CLR_NONE);
         if (result)
         {
            if (ShowAlerts==true) Alert("Take profit hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket());      
         }//if (result)
         else
         {
            int err=GetLastError();
            if (ShowAlerts==true) Alert("Take profit hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
            Print("Take profit hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
         }//else
      }//if (Ask >= tp)      
   }//if (OrderType() == OP_BUY)
   
   //Sell trade
   if (OrderType() == OP_SELL)
   {
      tp = NormalizeDouble(OrderOpenPrice() - (HiddenTakeProfitPips * Point), Digits);
      if (Ask <= tp)
      {
         result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5, CLR_NONE);
         if (result)
         {
            if (ShowAlerts==true) Alert("Take profit hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket());      
         }//if (result)
         else
         {
            err=GetLastError();
            if (ShowAlerts==true) Alert("Take profit hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
            Print("Take profit hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
         }//else
      }//if (Bid <= tp)   
   }//if (OrderType() == OP_SELL)
   

}//End void HiddenTakeProfit()

void TrailingStopLoss()
{
      if (TrailAfterBreakevenOnly && OrderType()==OP_BUY)
      {
         if(OrderStopLoss()<OrderOpenPrice()) return(0);
      }
     
      if (TrailAfterBreakevenOnly && OrderType()==OP_SELL)
      {
         if(OrderStopLoss()>OrderOpenPrice()) return(0);
      }
     
   
   
   bool result;
   double sl=OrderStopLoss(); //Stop loss
   double BuyStop=0, SellStop=0;
   
   if (OrderType()==OP_BUY) 
      {
         if (HideTrailingStop)
         {
            bool TradeClosed = CheckForHiddenStopLossHit(OP_BUY, PipsAwayFromVisualTS, OrderStopLoss() );
            if (TradeClosed) return;//Trade has closed, so nothing else to do
         }//if (HideJumpingStop)
		   
		   if (Bid >= OrderOpenPrice() + (TrailingStopPips*Point))
		   {
		       if (OrderStopLoss() == 0) sl = OrderOpenPrice();
		       if (Bid > sl +  (TrailingStopPips*Point))
		       {
		          sl= Bid - (TrailingStopPips*Point);
		          // Exit routine if user has chosen StopTrailAtPipsProfit and
		          // sl is past the profit Point already
		          if (StopTrailAtPipsProfit && sl>= OrderOpenPrice() + (StopTrailPips*Point)) return;
		          result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
               if (result)
               {
                  Print("Trailing stop updated: ", OrderSymbol(), ": SL ", sl, ": Ask ", Ask);
               }//if (result) 
               else
               {
                  int err=GetLastError();
                  Print(OrderSymbol(), " order modify failed with error(",err,"): ",ErrorDescription(err));
               }//else
   
		       }//if (Bid > sl +  (TrailingStopPips*Point))
		   }//if (Bid >= OrderOpenPrice() + (TrailingStopPips*Point))
      }//if (OrderType()==OP_BUY) 

      if (OrderType()==OP_SELL) 
      {
		   if (Ask <= OrderOpenPrice() - (TrailingStopPips*Point))
		   {
             if (HideTrailingStop)
             {
                TradeClosed = CheckForHiddenStopLossHit(OP_SELL, PipsAwayFromVisualTS, OrderStopLoss() );
                if (TradeClosed) return;//Trade has closed, so nothing else to do
             }//if (HideJumpingStop)
		   
		       if (OrderStopLoss() == 0) sl = OrderOpenPrice();
		       if (Ask < sl -  (TrailingStopPips*Point))
		       {
	               sl= Ask + (TrailingStopPips*Point);
  	               // Exit routine if user has chosen StopTrailAtPipsProfit and
		            // sl is past the profit Point already
		            if (StopTrailAtPipsProfit && sl<= OrderOpenPrice() - (StopTrailPips*Point)) return;
		            result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
                  if (result)
                  {
                     Print("Trailing stop updated: ", OrderSymbol(), ": SL ", sl, ": Bid ", Bid);
                  }//if (result)
                  else
                  {
                     err=GetLastError();
                     Print(OrderSymbol(), " order modify failed with error(",err,"): ",ErrorDescription(err));
                  }//else
    
		       }//if (Ask < sl -  (TrailingStopPips*Point))
		   }//if (Ask <= OrderOpenPrice() - (TrailingStopPips*Point))
      }//if (OrderType()==OP_SELL) 

      
} // End of TrailingStopLoss sub


void TradeManagementModule()
{

   // Call the working subroutines one by one. 

   //Cut down 5 digit order modify calls for 5 digit crims, if required
   static int NoOfTicks = 9;
   int ndigits = MarketInfo(Symbol(), MODE_DIGITS);
   if (DoNotOverload5DigitCriminals && ( ndigits == 3 || ndigits == 5) )
   {
      NoOfTicks++;
   }//if (DoNotOverload5DigitCriminals && ( digits == 3 || digits == 5) )
   
   if (!DoNotOverload5DigitCriminals || ndigits == 2 || ndigits == 4)
   {
      NoOfTicks = 10;
   }//if (!DoNotOverload5DigitCriminals || digits == 2 || digits == 4)
   
   
   // Global variable to pick up on failed part-closes
   //if (GlobalVariablesTotal()>0) GlobalVariablesExist=true;
   //if (GlobalVariablesExist && GlobalVariablesTotal()>0) TryPartCloseAgain();
   //if (GlobalVariablesExist && GlobalVariablesTotal()==0) GlobalVariablesExist=false;
   
   if (NoOfTicks >= 10)
   {
      NoOfTicks = 0;//Reset the counter
      
      // Hidden stop loss
      if (HideStopLossEnabled) HiddenStopLoss();
   
      // Hidden take profit
      if (HideTakeProfitEnabled) HiddenTakeProfit();
   
      // Tighten the stop loss
      //if (UseTigheningStop) TightenStopLoss();
      
      // Breakeven
      if(BreakEven) BreakEvenStopLoss();
   
      // JumpingStop
      if(JumpingStop) JumpingStopLoss();
   
      //TrailingStop
      if(TrailingStop) TrailingStopLoss();

   }//if (NoOfTicks >= 10)
   

}//void TradeManagementModule()
//END TRADE MANAGEMENT MODULE
////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////
//1.1.3.3 RECOVERY MODULE
void RecoveryModule()
{
   //My thanks to sundog for coding the change to 1.1.3.3
   
   //Check that recovery is necessary
   if (OrderType() == OP_BUY)
   {
      if (Ask > OrderOpenPrice() - (ReEntryLinePips * Point) ) return;
   }//if (OrderType() == OP_BUY)
   
   if (OrderType() == OP_SELL)
   {
      if (Bid < OrderOpenPrice() + (ReEntryLinePips * Point) ) return;
   }//if (OrderType() == OP_SELL)
   
   //Count no of open trades. The final one in the sequence will be the one that needs recovery
   CountOpenTrades();
   
   //If 1 trade open, then recovery is at the 1 stage
   if (OpenTrades == 1)
   {
      SendMagicNumber = MagicNumber + 20;
      LotSize = Lot * 1;
   }//if (OpenTrades == 1)
   
   
   //If 2 trades open, then recovery is at the 3 stage
   if (OpenTrades == 2)
   {
      SendMagicNumber = MagicNumber + 40;
      LotSize = Lot * 3;
   }//if (OpenTrades == 2)
   
   //If 3 trades open, then recovery is at the sedond 3  stage
   if (OpenTrades == 3)
   {
      SendMagicNumber = MagicNumber + 60;
      LotSize = Lot * 3;
   }//if (OpenTrades == 3)
   
   //Stop trading if the full 4-trade position is open
   if (OpenTrades == 4)
   {
      StopTrading = true;
   }//if (OpenTrades == 4)
   
   RecoveryInProgress = true;

   if (OpenTrades < 4)
   {
      int PrevOpenTrades = OpenTrades;

      TargetPrice = ObjectGetValueByShift(reentrylinename, 0);
      //Buy
      if (OrderType() == OP_BUY && Bid <= TargetPrice)
      {
         Buy(TradeComment);      
      }//if (OrderType() == OP_BUY && Bid <= TargetPrice)
   
      //Sell
      if (OrderType() == OP_SELL && Ask >= TargetPrice)
      {
         Sell(TradeComment);
      }//if (OrderType() == OP_SELL && Ask >= TargetPrice)
   }//if (OpenTrades < 4)
   
   if (OpenTrades > PrevOpenTrades)
   {
      ObjectDelete(reentrylinename);
      AddReEntryLine(OrderType() );
   }//if (OpenTrades > PrevOpenTrades)
   
   
}//End void RecoveryModule()

void CountOpenTrades()
{
   OpenTrades = 0;

   for (int cc = 0; cc < OrdersTotal(); cc++)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderSymbol() == Symbol() )
      {
         OpenTrades++;
      }//if (OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() )
   }//for (int cc = 0; cc < OrdersTotal() - 1; cc++)
   
   
}//End void CountOpenTrades();

void ModifyTakeProfit(double NewTake)
{
   TpMoved = true;
   
   for (int cc = OrdersTotal() -1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderTakeProfit() != NewTake)
      {
         TicketNo = OrderTicket();
         bool result = OrderModify(TicketNo, OrderOpenPrice(), OrderStopLoss(), NewTake, OrderExpiration(), CLR_NONE);
         if (!result) TpMoved = false;
      }//if (OrderTakeProfit() != NewTake)
      
   
   }//for (int cc = OrdersTotal() -1; cc >= 0; cc--)
   

}//End void ModifyTakeProfit(double NewTake);

void CheckRecoveryTakeProfit()
{

   ExtLines = 0;
   int    i,col,line;

   ArrayInitialize(ExtSymbolsSummaries,0.0);
   int total=Analyze();
   if(total>0)
   {
      line=0;
      for(i=0; i<ExtSymbolsTotal; i++)
      {
         if (ExtSymbols[i] != Symbol() ) continue;
         if(ExtSymbolsSummaries[i][DEALS]<=0) continue;
         line++;
         //---- add line
         if(line>ExtLines)
         {
            int y_dist=ExtVertShift*(line+1)+1;
            /*for(col=0; col<8; col++)
              {
               name="Line_"+line+"_"+col;
               if(ObjectCreate(name,OBJ_LABEL,windex,0,0))
                 {
                  ObjectSet(name,OBJPROP_XDISTANCE,ExtShifts[col]);
                  ObjectSet(name,OBJPROP_YDISTANCE,y_dist);
                 }
              }*/
            ExtLines++;
         }//if(line>ExtLines)
         //---- set line
         //color  price_colour;//Steve mod
         int    digits=MarketInfo(ExtSymbols[i],MODE_DIGITS);
         double buy_lots=ExtSymbolsSummaries[i][BUY_LOTS];
         double sell_lots=ExtSymbolsSummaries[i][SELL_LOTS];
         if(buy_lots!=0)  buy_price=NormalizeDouble(ExtSymbolsSummaries[i][BUY_PRICE]/buy_lots, Digits);
         if(sell_lots!=0) sell_price=NormalizeDouble(ExtSymbolsSummaries[i][SELL_PRICE]/sell_lots, Digits);
         
      }//for(i=0; i<ExtSymbolsTotal; i++)
   }//if(total>0)


}//End void CheckRecoveryTakeProfit()

int Analyze()
{
   double profit;
   int    i,index,type,total=OrdersTotal();
//----
   for(i=0; i<total; i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS)) continue;
      type=OrderType();
      if(type!=OP_BUY && type!=OP_SELL) continue;
      index=SymbolsIndex(OrderSymbol());
      if(index<0 || index>=SYMBOLS_MAX) continue;
      //----
      ExtSymbolsSummaries[index][DEALS]++;
      profit=OrderProfit()+OrderCommission()+OrderSwap();
      ExtSymbolsSummaries[index][PROFIT]+=profit;
      if(type==OP_BUY)
        {
         ExtSymbolsSummaries[index][BUY_LOTS]+=OrderLots();
         ExtSymbolsSummaries[index][BUY_PRICE]+=OrderOpenPrice()*OrderLots();
        }
      else
        {
         ExtSymbolsSummaries[index][SELL_LOTS]+=OrderLots();
         ExtSymbolsSummaries[index][SELL_PRICE]+=OrderOpenPrice()*OrderLots();
        }
     }
//----
   total=0;
   for(i=0; i<ExtSymbolsTotal; i++)
     {
      if(ExtSymbolsSummaries[i][DEALS]>0) total++;
     }
//----
   return(total);
}//int Analyze()

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int SymbolsIndex(string SymbolName)
{
   bool found=false;
//----
   for(int i=0; i<ExtSymbolsTotal; i++)
     {
      if(SymbolName==ExtSymbols[i])
        {
         found=true;
         break;
        }
     }
//----
   if(found) return(i);
   if(ExtSymbolsTotal>=SYMBOLS_MAX) return(-1);
//----
   i=ExtSymbolsTotal;
   ExtSymbolsTotal++;
   ExtSymbols[i]=SymbolName;
   ExtSymbolsSummaries[i][DEALS]=0;
   ExtSymbolsSummaries[i][BUY_LOTS]=0;
   ExtSymbolsSummaries[i][BUY_PRICE]=0;
   ExtSymbolsSummaries[i][SELL_LOTS]=0;
   ExtSymbolsSummaries[i][SELL_PRICE]=0;
   ExtSymbolsSummaries[i][NET_LOTS]=0;
   ExtSymbolsSummaries[i][PROFIT]=0;
//----
   return(i);
}//End int SymbolsIndex(string SymbolName)


//END 2.4.2 RECOVERY MODULE
////////////////////////////////////////////////////////////////////////////////////////////////




//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----

   if (TrendIsUp) trend = up;
   if (TrendIsDown) trend = down;
   if (AutoDetectTrend) GetTheTrend();
   bool TradeExists;
   OpenTrades = 0;
   
   
   //2.4.2 recovery   
   if (OrdersTotal() > 0) CountOpenTrades();
   if (OpenTrades > 1) RecoveryInProgress = true;
   if (OpenTrades == 0) 
   {
      RecoveryInProgress = false;
      TpMoved = true;
      LotSize = Lot;
      SendMagicNumber = MagicNumber;
      if (ObjectFind(TrendLineName) == -1) CalculateTrendLine();
      
   }//if (OpenTrades == 0) 
   
   if (RecoveryInProgress && !TpMoved)
   {
      //TradeExists = DoesTradeExist();//Identifies and selects the most recent trade
      CheckRecoveryTakeProfit();
      if (buy_price > 0) ModifyTakeProfit(buy_price);
      if (sell_price > 0) ModifyTakeProfit(sell_price);      
   }//if (RecoveryInProgress)
   
   

   
   ///////////////////////////////////////////////////////////////////////////////////////////////
   //Trade closure and management
   if (OrdersTotal() > 0) TradeExists = DoesTradeExist();
   
   if (TradeExists)
   {
      if (OrderProfit() < 0 && Use1.1.3.3Recovery) 
      {
         RecoveryModule();
         
      }//if (OrderProfit() < 0) 
      
      if (OpenTrades == 1)
      {
         TradeManagementModule();         
      }//if (!RecoveryInProgress)
      
   }//if (TradeExists)
   ///////////////////////////////////////////////////////////////////////////////////////////////
      
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   //Trading times
   int hour = TimeHour(TimeLocal() );
   
   if (end_hourm < start_hourm)
	{
		end_hourm += 24;
	}
	

	if (end_houre < start_houre)
	{
		end_houre += 24;
	}
	
	bool ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);

	// adjust for past-end-of-day cases
	// eg in AUS, USDJPY trades 09-17 and 22-06
	// so, the above check failed, check if it is because of this condition
	if (!ok2Trade && hour < 12)
	{
 		hour += 24;
		ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);		
		// so, if the trading hours are 11pm - 6am and the time is between  midnight to 11am, (say, 5am)
		// the above code will result in comparing 5+24 to see if it is between 23 (11pm) and 30(6+24), which it is...
	}


   // check for end of day by looking at *both* end-hours

   if (hour >= MathMax(end_hourm, end_houre))
   {      
      Comment("Outside trading hours\nstart_hourm-end_hourm: ", start_hourm, "-",end_hourm, "\nstart_houre-end_houre: ", start_houre, "-",end_houre);
      return;
   }//if (hour >= MathMax(end_hourm, end_houre))
   
   if (!ok2Trade)
   {
      Comment("Outside trading hours\nstart_hourm-end_hourm: ", start_hourm, "-",end_hourm, "\nstart_houre-end_houre: ", start_houre, "-",end_houre);
      return;
   }//if (hour < start_hourm)
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////////

       
   ///////////////////////////////////////////////////////////////////////////////////////////////         
   //Trading
   
   if (StopTrading)
   {
      TradingStatus = stopped;
      DisplayUserFeedback();
      return;
   }//if (StopTrading)
   
   if (OpenTrades > 0) 
   {
      DisplayUserFeedback();
      return;
   }//if (OpenTrades > 0) 
   
   int PrevOpenTrades = OpenTrades;
   
   TargetPrice = 0;
   TargetPrice = ObjectGetValueByShift(TrendLineName, 0);
   if (TargetPrice == 0) return;
   
   //Buy
   if (trend == up && Bid <= TargetPrice)
   {
      Buy(TradeComment);      
   }//if (trend == up && Bid <= TargetPrice)
   
   //Sell
   if (trend == down && Ask >= TargetPrice)
   {
      Sell(TradeComment);
   }//if (trend == down && Ask >= TargetPrice)
   
   //Delete existing trend line and replace with a different-coloured replica.
   //This both leaves the trader with a record of where the trend line was, and prepares
   //the robot for a replacement when the trade closes
   if (OpenTrades > PrevOpenTrades)
   {
      Leg1 = ObjectGet(TrendLineName, OBJPROP_PRICE1);
      Leg2 = ObjectGet(TrendLineName, OBJPROP_PRICE2);
      Leg1Time = ObjectGet(TrendLineName, OBJPROP_TIME1);
      Leg2Time = ObjectGet(TrendLineName, OBJPROP_TIME2);
      ObjectDelete(TrendLineName);
      DrawTrendLine(TrendLineRecordColour, oldtrendlinename);
   }//if (OpenTrades > PrevOpenTrades)
// double         Leg2, Leg1;
//int            Leg2Time, Leg1Time;
     
   ///////////////////////////////////////////////////////////////////////////////////////////////      
   
   DisplayUserFeedback();
   
//----
   return(0);
}
//+------------------------------------------------------------------+